diff -Naur u-boot-2013.01-2014_T3.0p2/arch/arm/lib/bootm.c u-boot-2013.01-2014_T3.0p2-tld-6/arch/arm/lib/bootm.c
--- u-boot-2013.01-2014_T3.0p2/arch/arm/lib/bootm.c	2016-07-18 23:40:40.000000000 -0700
+++ u-boot-2013.01-2014_T3.0p2-tld-6/arch/arm/lib/bootm.c	2017-06-08 21:06:13.000000000 -0700
@@ -141,14 +141,14 @@
 {
 	ulong value32=0;
 	
-	/* disable USB power and USB led */
+	/* disable USB power and USB led 
 	value32 = *((ulong  *)(0xF1018140));
 	if ( ( value32 & 0x1000) != 0 )
 	{
   	run_command("usb stop;",0);
   	value32 &= 0xffffefdf;
   	*((ulong  *)(0xF1018140)) = value32;
-	}
+	} */
 	
 	printf("\nStarting kernel ...\n\n");
 	bootstage_mark_name(BOOTSTAGE_ID_BOOTM_HANDOFF, "start_kernel");
diff -Naur u-boot-2013.01-2014_T3.0p2/board/mv_ebu/a38x/mv_main_a38x.c u-boot-2013.01-2014_T3.0p2-tld-6/board/mv_ebu/a38x/mv_main_a38x.c
--- u-boot-2013.01-2014_T3.0p2/board/mv_ebu/a38x/mv_main_a38x.c	2016-07-18 23:40:43.000000000 -0700
+++ u-boot-2013.01-2014_T3.0p2-tld-6/board/mv_ebu/a38x/mv_main_a38x.c	2017-06-30 16:07:37.433141579 -0700
@@ -34,6 +34,7 @@
 *******************************************************************************/
 
 #include <common.h>
+#include <environment.h>
 #include "mvTypes.h"
 #include "mvBoardEnvLib.h"
 #include "mvBoardEnvSpec.h"
@@ -153,7 +154,7 @@
 	}
 #endif
 	printf("       Heap:\t\t\t0x%08x:0x%08x\n", (unsigned int)(gd->relocaddr - TOTAL_MALLOC_LEN), (unsigned int)gd->relocaddr);
-	printf("       U-Boot Environment:\t0x%08x:0x%08x ", CONFIG_ENV_OFFSET, CONFIG_ENV_OFFSET + CONFIG_ENV_SIZE);
+	printf("       U-Boot Environment:\t0x%08x:0x%08x Address: 0x%08x", CONFIG_ENV_OFFSET, CONFIG_ENV_OFFSET + CONFIG_ENV_SIZE, CONFIG_ENV_ADDR);
 #ifdef MV_NAND_BOOT
 	printf("(NAND)\n\n");
 #elif defined(MV_SPI_BOOT)
@@ -251,6 +252,8 @@
 
 int board_init(void)
 {
+        char *env;
+
 	DECLARE_GLOBAL_DATA_PTR;
 
 	if (whoAmI() != 0)
@@ -285,10 +288,6 @@
 	/* Initialize SSCG in case enabled by Sample-at-reset. */
 	mvCtrlSSCGInit();
 
-#ifdef MV_NOR_BOOT
-	env_init();
-#endif
-
 	/* Init the GPIO sub-system */
 	MV_GPP_HAL_DATA gppHalData;
 	gppHalData.ctrlRev = mvCtrlRevGet();
@@ -676,8 +675,13 @@
 
   /* Check push USB button */
   value = MV_REG_READ(0x18150);
-  if ( ( value & 0x00800000 ) != 0 )
-    setenv("bootcmd","nand read.e 0xa00000 0x500000 0x500000;nand read.e 0xf00000 0xa00000 0x500000;bootm 0xa00000 0xf00000");
+  if ( ( value & 0x00800000 ) != 0 ) {
+	setenv("bootcmd","run bootcmd_custom; setenv bootargs root=/dev/ram console=ttyS0,115200; nand read.e 0xa00000 0x500000 0x500000;nand read.e 0xf00000 0xa00000 0x500000;bootm 0xa00000 0xf00000");
+	env = getenv("bootcmd");
+        if (env) {
+		printf ("bootcmd: %s\n", env);
+	}
+  }
   else
   {
     /* push usb botton , boot form USB */
diff -Naur u-boot-2013.01-2014_T3.0p2/include/config_cmd_default.h u-boot-2013.01-2014_T3.0p2-tld-6/include/config_cmd_default.h
--- u-boot-2013.01-2014_T3.0p2/include/config_cmd_default.h	2016-07-18 23:40:44.000000000 -0700
+++ u-boot-2013.01-2014_T3.0p2-tld-6/include/config_cmd_default.h	2017-06-11 13:44:42.000000000 -0700
@@ -35,7 +35,7 @@
 #define CONFIG_CMD_NET		/* bootp, tftpboot, rarpboot	*/
 #define CONFIG_CMD_NFS		/* NFS support			*/
 #define CONFIG_CMD_RUN		/* run command in env variable	*/
-//#define CONFIG_CMD_SAVEENV	/* saveenv			*/
+#define CONFIG_CMD_SAVEENV	/* saveenv			*/
 #define CONFIG_CMD_SETGETDCR	/* DCR support on 4xx		*/
 #define CONFIG_CMD_SOURCE	/* "source" command support	*/
 #define CONFIG_CMD_XIMG		/* Load part of Multi Image	*/
diff -Naur u-boot-2013.01-2014_T3.0p2/include/configs/armada_38x.h u-boot-2013.01-2014_T3.0p2-tld-6/include/configs/armada_38x.h
--- u-boot-2013.01-2014_T3.0p2/include/configs/armada_38x.h	2016-07-18 23:40:44.000000000 -0700
+++ u-boot-2013.01-2014_T3.0p2-tld-6/include/configs/armada_38x.h	2017-06-23 02:44:06.000000000 -0700
@@ -367,7 +367,7 @@
 		#define CONFIG_ENV_IS_IN_NAND
 
 		#define CONFIG_ENV_SIZE                 0x80000                 /* environment takes one erase block */
-		#define CONFIG_ENV_OFFSET               nand_get_env_offs()     /* environment starts here  */
+		#define CONFIG_ENV_OFFSET               0x100000     /* environment starts here  */
 		#define CONFIG_ENV_ADDR                 CONFIG_ENV_OFFSET
 		#define MONITOR_HEADER_LEN              0x200
 		#define CONFIG_SYS_MONITOR_BASE         0
diff -Naur u-boot-2013.01-2014_T3.0p2/include/configs/mv_version.h u-boot-2013.01-2014_T3.0p2-tld-6/include/configs/mv_version.h
--- u-boot-2013.01-2014_T3.0p2/include/configs/mv_version.h	2016-07-18 23:40:44.000000000 -0700
+++ u-boot-2013.01-2014_T3.0p2-tld-6/include/configs/mv_version.h	2017-06-30 16:02:01.877230880 -0700
@@ -39,6 +39,6 @@
 /*
  * Version
  */
-#define CONFIG_IDENT_STRING	" Marvell version: 2014_T3.0p6"
+#define CONFIG_IDENT_STRING	" Marvell version: 2014_T3.0p6 - bodhi-tld-6"
 
 #endif /* __MV_VERSION_H */
diff -Naur u-boot-2013.01-2014_T3.0p2/xbuild.sh u-boot-2013.01-2014_T3.0p2-tld-6/xbuild.sh
--- u-boot-2013.01-2014_T3.0p2/xbuild.sh	2016-07-18 23:40:41.000000000 -0700
+++ u-boot-2013.01-2014_T3.0p2-tld-6/xbuild.sh	2017-06-30 16:03:11.214413615 -0700
@@ -10,7 +10,7 @@
 xbuild(){
 	make mrproper
 	#./build.pl -f nand -v YellowStone_2014T2_PQ -b armada_38x -i nand -c -o $(pwd)
-	./build.pl -f nand -v Yollowstone_2014T30p6_QA -b armada_38x -i nand -c -o $(pwd)
+	./build.pl -f nand -v Yellowstone_2014T30p6_bodhi-tld-6 -b armada_38x -i nand -c -o $(pwd)
 }
 
 xclean()
